#!/bin/bash
LANG=en_US.utf8
LC_ALL=en_US.utf8
unameout="$(uname -s)"

dtt=`date --date "0 day ago" "+%Y%m%d"`
dt=`date --date "0 day ago" "+%d%b%Y"`
iwk1=`date --date "-1 day ago" "+%d%b%Y"`
iwk2=`date --date "-8 day ago" "+%d%b%Y"`
iwk3=`date --date "-15 day ago" "+%d%b%Y"`
iwk34=`date --date "-15 day ago" "+%d%b%Y"`
iwk1234=`date --date "-1 day ago" "+%d%b%Y"`

fwk1=`date --date "-7 day ago" "+%d%b%Y"`
fwk2=`date --date "-14 day ago" "+%d%b%Y"`
fwk3=`date --date "-21 day ago" "+%d%b%Y"`
fwk34=`date --date "-28 day ago" "+%d%b%Y"`
fwk1234=`date --date "-28 day ago" "+%d%b%Y"`

for wk in 1 2 34; do

if [ $wk = 1 ]; then iwk=$iwk1; fwk=$fwk1; fi
if [ $wk = 2 ]; then iwk=$iwk2; fwk=$fwk2; fi
if [ $wk = 3 ]; then iwk=$iwk3; fwk=$fwk3; fi
if [ $wk = 34 ]; then iwk=$iwk34; fwk=$fwk34; fi
if [ $wk = 1234 ]; then iwk=$iwk1234; fwk=$fwk1234; fi

iwkk=$(date -d"$iwk + 0 day" +"%d%b")
fwkk=$(date -d"$fwk + 0 day" +"%d%b")

rm train_data/gefs_week${wk}_tercile.nc
wget --no-check-certificate https://ftp.cpc.ncep.noaa.gov/International/subseasonal2/gefs_week${wk}_tercile.nc
mv gefs_week${wk}_tercile.nc train_data/

cat>gen_raw.py<<eofPY
import xcast as xc
import xarray as xr
import cartopy.crs as ccrs
import numpy as np
import matplotlib.pyplot as plt
#import rioxarray
#import geopandas as gpd
from shapely.geometry import mapping

wlon= $1
elon= $2
slat = $3
nlat = $4

longrid = np.arange(wlon, elon + 10,10)
latgrid = np.arange(slat, nlat + 10,10)

longridl = longrid.tolist()
latgridl = latgrid.tolist()


fmodel = xr.open_dataset('train_data/gefs_week${wk}_tercile.nc').precip

fmodel = fmodel.sel(lon=slice(wlon, elon), lat=slice(slat, nlat))

import sys
sys.path.append('./libs')

import matplotlib.ticker as mticker
from cartopy.mpl.gridliner import LONGITUDE_FORMATTER, LATITUDE_FORMATTER
from prob import pview_probabilistic
ax = pview_probabilistic(fmodel.isel(time=0), ocean=False, title='GEFS, Week-${wk}, Raw, Valid: ${iwk} - ${fwk}')
gl = ax.gridlines(crs=ccrs.PlateCarree(), linewidth=1, color='blue', alpha=0.5, linestyle='--', draw_labels=True)
gl.top_labels = False
gl.left_labels = False
gl.right_labels=True
gl.xlines = True
gl.xlocator = mticker.FixedLocator(longridl)
gl.ylocator = mticker.FixedLocator(latgridl)
gl.xformatter = LONGITUDE_FORMATTER
gl.yformatter = LATITUDE_FORMATTER
gl.xlabel_style = {'color': 'black'}
gl.top_labels = False
gl.left_labels = True
gl.right_labels=False
gl.bottom_labels=True
plt.savefig('fig_dir/gefs_week_${wk}_raw.png', dpi=300)

eofPY

python gen_raw.py

convert -trim fig_dir/gefs_week_${wk}_raw.png fig_dir/gefs_week_${wk}_raw.png
convert -bordercolor white -border 10  fig_dir/gefs_week_${wk}_raw.png fig_dir/gefs_week_${wk}_raw.png

done
