#!/bin/bash
############################################################
# This Shell script and the embeded python scripts are used to
# Download Predictor and Predictand Data, and generate plots
# for Week-1 / Week-2  & Week 3-4 Calibrated Precip Forecasts
# for the domain of your interest
# Written by Endalkachew Bekele, NOAA/CPC/International Desks, August 2024
# subseasonal_calib_python.sh (version 1.0)

LANG=en_US.utf8
LC_ALL=en_US.utf8
unameout="$(uname -s)"

if [ "$#" -ne 4 ]; then
    echo "***************************************************************************************************************************"
    echo " error while running plot_all.sh"
    echo "----------------- You need to provide 4 arguments -------------------------------------------------------------------------"
    echo "***************************************************************************************************************************"
    echo
    echo "The four arguments reflect geographical extent of your area:"
    echo
    echo "western lon, eastern lon, southern lat and northern lat in degreas, respectively"
    echo
    echo "Use negative sign for longitudes in western, and latitudes in the southern hemisphere"
    echo
    echo "For example, if your area extends from 18W to 11W and from 12N to 17N .."
    echo " you may run the script as .."
    echo
    echo " bash subseasonal_calib_python.sh -18 -11 12 17"
    echo
    echo
exit
fi

rm *.py

bash gen_gefs_raw.sh $1 $2 $3 $4
bash gen_gefs_cca.sh $1 $2 $3 $4
bash gen_gefs_elr.sh $1 $2 $3 $4
bash gen_gefs_epoelm.sh $1 $2 $3 $4
bash gen_gefs_cca_elr_epoelm_cons.sh $1 $2 $3 $4

if [ $unameout = "Darwin" ]; then
   /Applications/Google\ Chrome.app/Contents/MacOS/Google\ Chrome index.html&
   open -a Safari index.html&
else
    firefox index.html&
    google-chrome index.html&
    cygstart index.html
fi

